# Basics

## Return codes

group (Return Codes)

  Defines

  DDS_RETCODE_OK (0)

    Success

  DDS_RETCODE_ERROR (-1)

    Non specific error

  DDS_RETCODE_UNSUPPORTED (-2)

    Feature unsupported

  DDS_RETCODE_BAD_PARAMETER (-3)

    Bad parameter value

  DDS_RETCODE_PRECONDITION_NOT_MET (-4)

    Precondition for operation not met

  DDS_RETCODE_OUT_OF_RESOURCES (-5)

    When an operation fails because of a lack of resources

  DDS_RETCODE_NOT_ENABLED (-6)

    When a configurable feature is not enabled

  DDS_RETCODE_IMMUTABLE_POLICY (-7)

    When an attempt is made to modify an immutable policy

  DDS_RETCODE_INCONSISTENT_POLICY (-8)

    When a policy is used with inconsistent values

  DDS_RETCODE_ALREADY_DELETED (-9)

    When an attempt is made to delete something more than once

  DDS_RETCODE_TIMEOUT (-10)

    When a timeout has occurred

  DDS_RETCODE_NO_DATA (-11)

    When expected data is not provided

  DDS_RETCODE_ILLEGAL_OPERATION (-12)

    When a function is called when it should not be

  DDS_RETCODE_NOT_ALLOWED_BY_SECURITY (-13)

    When credentials are not enough to use the function

  DDS_XRETCODE_BASE (-50)

    Base offset for extended return codes

  DDS_XRETCODE(x) (DDS_XRETCODE_BASE - (x))

    Extended return code generator

  DDS_RETCODE_IN_PROGRESS DDS_XRETCODE(1)

    Requested resource is busy

  DDS_RETCODE_TRY_AGAIN DDS_XRETCODE(2)

    Resource unavailable, try again

  DDS_RETCODE_INTERRUPTED DDS_XRETCODE(3)

    Operation was interrupted

  DDS_RETCODE_NOT_ALLOWED DDS_XRETCODE(4)

    Permission denied

  DDS_RETCODE_HOST_NOT_FOUND DDS_XRETCODE(5)

    Host not found

  DDS_RETCODE_NO_NETWORK DDS_XRETCODE(6)

    Network is not available

  DDS_RETCODE_NO_CONNECTION DDS_XRETCODE(7)

    Connection is not available

  DDS_RETCODE_NOT_ENOUGH_SPACE DDS_XRETCODE(8)

    Not enough space available

  DDS_RETCODE_OUT_OF_RANGE DDS_XRETCODE(9)

    Result too large

  DDS_RETCODE_NOT_FOUND DDS_XRETCODE(10)

    Not found

  Functions

  const char *dds_strretcode(dds_return_t ret)

    Takes the error value and outputs a string corresponding to it.

    Parameters:

      - ret – [in] Error value to be converted to a string

    Returns:

      String corresponding to the error value